/*
 *
 * j-chkmail - filtre de messagerie pour sendmail - MILTER
 *
 * Copyright (c) 2001, 2002 Ecole des Mines de Paris
 *
 *  Auteur     : Jose Marcio Martins da Cruz
 *               martins@paris.ensmp.fr
 *
 *  Historique :
 *  Creation     : janvier 2002
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _J_FILEEXP_H_

int                 free_fext ();
int                 add_fext (char *);

int                 free_fregex ();
int                 add_fregex (char *);

void                init_default_file_extensions ();
void                init_file_extension_regex ();
void                list_filename_extensions ();

int                 check_filename_regex (char *);
int                 check_filename_extension (char *);
int                 check_filename (char *);

extern char        *J_FILE_EXT;
extern char        *J_DEFAULT_EXT;

typedef struct fext_rec {
  char                expr[64];
  regex_t             re;
  int                 reg_ok;
  char                remark[32];
} fext_rec;

typedef struct fregex_rec {
  char                expr[64];
  regex_t             re;
  int                 reg_ok;
  char                remark[32];
} fregex_rec;

extern fext_rec    *j_fext;
extern int          sz_fext;
extern int          nb_fext;

extern fregex_rec  *j_fregex;
extern int          sz_fregex;
extern int          nb_fregex;


#define _J_FILEEXP_H_
#endif
