/*
 *
 * j-chkmail - filtre de messagerie pour sendmail - MILTER
 *
 * Copyright (c) 2001, 2002 Ecole des Mines de Paris
 *
 *  Auteur     : Jose Marcio Martins da Cruz
 *               martins@paris.ensmp.fr
 *
 *  Historique :
 *  Creation     : janvier 2002
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef __JMSG_H__

/* Pre-processing */
/* Not already done */
#if MSG_LANG == LANG_FR
#undef MSG_LANG
#endif

/* Not already done */
#if MSG_LANG == LANG_DE
#undef MSG_LANG
#endif

#if !defined(MSG_LANG)
#define MSG_LANG  LANG_EN
#endif


/* Now, let's go ! */

/* English language messages */
#if MSG_LANG == LANG_EN

#define  MSG_NO_PEER_HOSTNAME       "*** No peer hostname when connecting"
#define  MSG_XFILE                  "*** A suspicious file (executable code) was found in the message !"
#define  MSG_NO_FROM_HEADER         "*** There is no From header field"
#define  MSG_NO_RCPT_HEADER         "*** There is no To, CC or Bcc header field"
#define  MSG_NO_SUBJECT_HEADER      "*** There is no Subject Header"
#define  MSG_NO_HEADERS             "*** There are no headers..."
#define  MSG_INTRANET_USER          "*** Mail to intranet user from outside world..."
#define  MSG_LOCAL_USER             "*** %s can receive mail only from local network"
#define  MSG_BINARY_MESSAGE         "*** Trying a buffer overflow ??? - Let's discard it ! "
#define  MSG_VIRUS                  "*** A virus was detected in your message"
#define  MSG_OUTLOOK                "*** Outlook Express not allowed from the network you are in"
#define  MSG_TOO_MUCH_RCPT          "*** Too much recipients for this message"
#define  MSG_ADDRESS_OUTSIDE_DOMAIN "*** %s From address outside %s network (%s)"

#define  MSG_RESOLVE_FAIL           "*** RESOLVE : mail gateway DNS lookup failed"
#define  MSG_RESOLVE_FORGED         "*** RESOLVE : mail gateway hostname seems to be forged"

#define  MSG_THROTTLE_EXCEEDED      "*** CONN THROTTLE : too high"
#define  MSG_RCPT_THROTTLE_EXCEEDED "*** RCPT THROTTLE : too high"

#define  MSG_SUBJECT_CONTENTS       "*** Subject contents violates site policy"
#define  MSG_HEADERS_CONTENTS       "*** Header contents violates site policy"
#define  MSG_BODY_CONTENTS          "*** Sorry, this server is configured to refuse this kind of mail (SPAM)"
#define  MSG_HELO_CONTENTS          "*** HELO contents : strange !!!"

#define  MSG_TEXT_NOT_ALLOWED       "*** MESSAGE CONTENTS VIOLATE SITE POLICY"

#define  MSG_ENCODED_BODY           "*** We don't accept encoded messages"
#define  MSG_BODY_ENCODED_BINARY    "*** No BINARY messages !"
#define  MSG_BODY_ENCODED_BASE64    "*** No BASE 64 messages !"
#define  MSG_BODY_ENCODED_QP        "*** No QUOTED PRINTABLE messages !"

#define  MSG_SHORT_VIRUS            "*** VIRUS"
#define  MSG_SHORT_ATTACHMENT       "*** ATTACHMENT"
#define  MSG_SHORT_XFILE            "*** XFILES"
#define  MSG_SHORT_RESOLVE          "*** client_resolve : %s : %s"
#define  MSG_SHORT_THROTTLE         "*** THROTTLE : too high : %s : %d [%02X]"
#define  MSG_SHORT_POLICY           "*** POLICY..."

#endif             /* LANG_EN */

#define __JMSG_H__
#endif
